__gnu_cxx::bitmap_allocator(3)

NAME
__gnu_cxx::bitmap_allocator -

SYNOPSIS

Inherits free_list.

Detailed Description

  template<typename _Tp> class __gnu_cxx::bitmap_allocator< _Tp >

Definition at line 867 of file bitmap_allocator.h.

  Public Types
typedef const _Tp * const_pointer
typedef const _Tp & const_reference
typedef std::ptrdiff_t difference_type
typedef _Tp * pointer
typedef _Tp & reference
typedef std::size_t size_type
typedef _Tp value_type

  Public Member Functions
pointer _M_allocate_single_object () throw (std::bad_alloc)
void _M_deallocate_single_object (pointer __p) throw ()
const_pointer address (const_reference __r) const
pointer address (reference __r) const
pointer allocate (size_type __n, typename bitmap_allocator< void >::const_pointer)
pointer allocate (size_type __n)
template<typename _Tp1> bitmap_allocator (const bitmap_allocator< _Tp1 > &) throw ()
bitmap_allocator (const bitmap_allocator &)
bitmap_allocator () throw ()
void construct (pointer __p, const_reference __data)
void deallocate (pointer __p, size_type __n) throw ()
void destroy (pointer __p)
size_type max_size () const throw ()
~bitmap_allocator () throw ()

  Classes
struct rebind

Member Function Documentation

  pointer _M_allocate_single_object () throw (std::bad_alloc) [inline]

Allocates memory for a single object of size sizeof(_Tp).

Exceptions:
    std::bad_alloc. If memory can not be allocated.

Complexity: Worst case complexity is O(N), but that is hardly ever hit. If and when this particular case is encountered, the next few cases are guaranteed to have a worst case complexity of O(1)! That's why this function performs very well on average. You can consider this function to have a complexity referred to commonly as: Amortized Constant time.

Definition at line 1001 of file bitmap_allocator.h.

References __gnu_cxx::balloc::__bit_allocate(), __gnu_cxx::balloc::__find_if(), __gnu_cxx::balloc::__num_bitmaps(), __gnu_cxx::_Bit_scan_forward(), __mini_vector::begin(), __mini_vector::end(), and __mini_vector::size().

Referenced by bitmap_allocator::allocate().

  void _M_deallocate_single_object (pointer __p) throw () [inline]

Deallocates memory that belongs to a single object of size sizeof(_Tp).

Complexity: O(lg(N)), but the worst case is not hit often! This is because containers usually deallocate memory close to each other and this case is handled in O(1) time by the deallocate function.

Definition at line 1099 of file bitmap_allocator.h.

References __gnu_cxx::balloc::__bit_free(), __gnu_cxx::balloc::__find_if(), __gnu_cxx::balloc::__num_bitmaps(), std::__rotate(), _BALLOC_ASSERT, free_list::_M_insert(), __mini_vector::begin(), __mini_vector::end(), __mini_vector::erase(), and __mini_vector::size().

Referenced by bitmap_allocator::deallocate().

Author

Generated automatically by Doxygen for libstdc++ from the source code.